clear
clc
cd('Z:\RESEARCH\HW1_20090706_identification and estimation\20100803_clean code\20110525_2FM1');

load mature
load data_part_loggdp
%% OLS regresion
fm = data.fm;
Y_1 = data.Y_1/400;
Y_2 = data.Y_2/400;
T = length(Y_1)-1;

ym  = fm(2:end,:);
xm = [ones(T,1),fm(1:end-1,:),Y_1(1:end-1,:)];
param = xm\ym;
Am_star = param(1,:)';
phi_starmm = param(2:3,:)';
phi_starm1 = param(4:end,:)';
umt_star = ym-xm*param;                                     %umt_star is T*2
var_m = var_OLS(umt_star);

y1 = Y_1(2:end,:);
x1 = [ones(T,1),fm(1:end-1,:),Y_1(1:end-1,:),fm(2:end,:)];
%x1 = [ones(T,1),fm(1:end-1,:),Y_1(1:end-1,:),umt_star];
para1 = x1\y1;
A1_star  = para1(1,:)';
phi_star1m = para1(2:3,:)';
phi_star11 = para1(4:6,:)';
phi_star10 = para1(7:end,:)';
u1t_star = y1 - x1*para1;
var_1 = var_OLS(u1t_star);

y2 = Y_2(2:end,:);
x2 = [ones(T,1),fm(2:end,:),Y_1(2:end,:)];
para2 = x2\y2;
A2_star = para2(1,:)';
phi_star2m = para2(2:3,:)';
phi_star21 = para2(4:end,:)'; 
u2t_star = y2 - x2*para2;
%bm = var_OLS(u2t_star);
bm = std(u2t_star);

%% Solve deep parameters
options  =  optimset('fsolve');
options  =  optimset(options , 'Display'     , 'iter');
options  = optimset(options, 'Algorithm','levenberg-marquardt');           %updated 08/04/2009, faster for square system
options  = optimset(options, 'MaxFunEvals',100000);
options  = optimset(options, 'MaxIter',10000);
options  = optimset(options, 'TolFun',1e-20);

%----------------------- group 1 ------------------------------------------
% solve sig_mm analytically from var_m
sig_mm = chol(var_m)';
sig = blkdiag(sig_mm,eye(3));
%----------------------- group 2 ------------------------------------------
% solve rhoQ and delta1 numerically
B1m  = phi_star10;
B1B1 = var_1;
B2B1 = phi_star21*var_1;
B2m  = phi_star2m+phi_star21*B1m;

delta1 = ones(5,1)*1e-3;
temp = B1m(1,:);
delta1(1:2) = temp;
rhoQ_m = diag(rand(2,1)/2+0.5);
rhoQ_l = diag(rand(3,1)/2+0.5);

rhoQ = blkdiag(rhoQ_m,rhoQ_l);
parameters = rhoQdelta1_ind2vec(rhoQ,delta1);

for i = 1:10
    initial = parameters;
    [parameters,f] = fsolve(@(para) phi2rhoQdelta1(para,mature,B1m,B2m,B1B1,B2B1), initial,options);
end
   
[rhoQ, delta1] = rhoQdelta1_vec2ind(parameters);

rhoQ(delta1 < 0,:) = -rhoQ(delta1 < 0,:);                                   % normalize delta1 to be positive
rhoQ(:,delta1 < 0) = -rhoQ(:,delta1 < 0);
delta1(delta1 < 0) = -delta1(delta1 < 0);

if rhoQ(4,5) > rhoQ(5,4)
    temp = rhoQ(5,:);
    rhoQ(5,:) = rhoQ(4,:);
    rhoQ(4,:) = temp;
    temp = rhoQ(:,5);
    rhoQ(:,5) = rhoQ(:,4);
    rhoQ(:,4) =temp;
    temp = delta1(5);
    delta1(5) = delta1(4);
    delta1(4) = temp;
end

parameters = rhoQdelta1_ind2vec(rhoQ,delta1);
%-----------------------group 3-------------------------------------------
[F,B1m,B2m,B1l,B2l] = phi2rhoQdelta1(parameters,mature);
rho_ml = phi_starm1*B1l;
rho_mm = phi_starmm + rho_ml/B1l*B1m;
rho_ll = B1l\phi_star11*B1l;
rho_lm = B1l\(phi_star1m  + B1l*rho_ll/B1l*B1m);
rho = [rho_mm,rho_ml;rho_lm,rho_ll];

%---------------------group 4----------------------------------------------
delta0 = 0;
cQ = [0.68;-0.25];
parameters = [delta0;cQ];
for i = 1:10
    initial = parameters;
    parameters = fsolve(@(para) A2cQdelta0(para,mature,rhoQ,delta1,sig,A2_star,B1l,B2l), parameters,options);
end
[F,A1,A2,B_bar_temp] = A2cQdelta0(parameters,mature,rhoQ,delta1,sig,A2_star,B1l,B2l);
cQ = zeros(5,1);
cQ(1:2)   = parameters(2:end);
delta0 = parameters(1);
cm = Am_star + rho_ml/B1l*A1;
cl = B1l\(A1_star-A1+B1l*rho_ll/B1l*A1);
c = [cm;cl];

save para_identified rhoQ delta1 rho cQ delta0 sig c