clear
clc
cd('Z:\RESEARCH\HW1_20090706_identification and estimation\20100803_clean code\20110525_2FM1');

load mature
load data_part_loggdp
load para_identified

%% OLS regresion
fm = data.fm;
Y_1 = data.Y_1/400;
Y_2 = data.Y_2/400;
T = length(Y_1)-1;

ym  = fm(2:end,:);
xm = [ones(T,1),fm(1:end-1,:),Y_1(1:end-1,:)];
param = xm\ym;
Am_star = param(1,:)';
phi_starmm = param(2:3,:)';
phi_starm1 = param(4:end,:)';
umt_star = ym-xm*param;                                     %umt_star is T*2
var_m = var_OLS(umt_star);
SIGmm = chol(var_m)';

y1 = Y_1(2:end,:);
x1 = [ones(T,1),fm(1:end-1,:),Y_1(1:end-1,:),fm(2:end,:)];
para1 = x1\y1;
A1_star  = para1(1,:)';
phi_star1m = para1(2:3,:)';
phi_star11 = para1(4:6,:)';
phi_star10 = para1(7:end,:)';
u1t_star = y1 - x1*para1;
var_1 = var_OLS(u1t_star);

y2 = Y_2(2:end,:);
x2 = [ones(T,1),fm(2:end,:),Y_1(2:end,:)];
para2 = x2\y2;
A2_star = para2(1,:)';
phi_star2m = para2(2:3,:)';
phi_star21 = para2(4:end,:)'; 
u2t_star = y2 - x2*para2;
SIGe = std(u2t_star);
SIGe =diag(SIGe);


%% information matrix and asymptotic std error
Hm = kron(inv(var_m),xm'*xm);
d = duplication(size(var_m,1));
Hmv = T/2*d'*kron(inv(var_m),inv(var_m))*d;
H1 = kron(inv(var_1),x1'*x1);
d = duplication(size(var_1,1));
H1v = T/2*d'*kron(inv(var_1),inv(var_1))*d;
H2 = kron(inv(SIGe.^2),x2'*x2);
d = duplication(size(SIGe,1));
H2v = T/2*d'*kron(inv(SIGe.^2),inv(SIGe.^2))*d;
H2v = H2v([1,4,6],[1,4,6]);

R = blkdiag(Hm,Hmv,H1,H1v,H2,H2v);
paraSTR_vec = para_ind2vec_MF1(cQ, c,rhoQ, rho, delta1, delta0,SIGe,SIGmm);
GAMMA = numgrad('para_str2OLS_MF1',paraSTR_vec,mature);

variance = inv(GAMMA'*R*GAMMA);
para_std = sqrt(diag(variance));
[cQ_std, c_std,rhoQ_std, rho_std, delta1_std, delta0_std,SIGe_std,SIGmm_std] = para_vec2ind_MF1(para_std); 
save asympt_std rhoQ_std delta1_std rho_std cQ_std c_std delta0_std SIGe_std SIGmm_std

cQ./cQ_std
c./c_std
rhoQ./rhoQ_std
rho./rho_std
delta0/delta0_std
delta1./delta1_std
SIGe./SIGe_std
SIGmm./SIGmm_std