function [cQ, c,rhoQ, rho, delta1, delta0,SIGe,SIGmm] = para_vec2ind_MF1(para)  
% para_vec2ind_Latent passes values from a vector 'para' to individual
% parameters, it supports single or multiple factor pure latent models
%
% INPUTS:   para:   the vector of parameters containg all info and used as a
%                   companion form for estimation purpose et al.
% OUTPUTS:  rhoQ, delta1, rho, muQ, delta0: parameters from no arbitrage
%           structure
% last updated 04/05/2010

Nl = 3;   
Nm = 2;
Ne = 3;
Nf = Nl + Nm;

nn = Nf*(Nf+1) - 3;
[rhoQ, delta1] = rhoQdelta1_vec2ind(para(1:nn));
nn_ = nn + Nf^2;
rho      = reshape(para(nn+1:nn_),Nf,Nf);
nn = nn_ + Nm;
cQ = zeros(Nf,1);
cQ(1:Nm)  = para(nn_+1:nn)/10;
nn_ = nn+Nf;
c = para(nn+1:nn_);
nn = nn_+1;
delta0 = para(nn_+1:nn)/100;
nn_ = nn+Ne;
SIGe = diag(para(nn +1:nn_))/1e3;
SIGmm = veclt(para(nn_+1:end));

 