function [F,B1m,B2m,B1l,B2l] = phi2rhoQdelta1(para,mature,B1m_OLS,B2m_OLS,B1B1_OLS,B2B1_OLS)
% last updated 08/04/2009

Nm = 2;
Nl = length(mature.exact);
Ne = length(mature.error);

[rhoQ, delta1] = rhoQdelta1_vec2ind(para);

B1 = zeros(Nl,Nm+Nl);
for i = 1:Nl
    B1(i,:) = ((rhoQ')^mature.exact(i)-eye(Nm+Nl))/(rhoQ'-eye(Nm+Nl))/mature.exact(i)*delta1;
end

B2 = zeros(Ne,Nm+Nl);
for i = 1:Ne
    B2(i,:) = ((rhoQ')^mature.error(i)-eye(Nm+Nl))/(rhoQ'-eye(Nm+Nl))/mature.error(i)*delta1;
end

B1m = B1(:,1:Nm);
B1l = B1(:,Nm+1:end);
B2m = B2(:,1:Nm);
B2l = B2(:,Nm+1:end);

if nargin > 2
temp1 = B1m_OLS - B1m;
temp2 = B2m_OLS - B2m;
temp3 = B1B1_OLS - B1l*B1l';
temp4 = B2B1_OLS - B2l*B1l';

F = [temp1(:);temp2(:);ltvec(temp3)*400;temp4(:)*400]*1e7;
else
    F = NaN;
end




